WriterPlsParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
WriterPlsParser Class Referencefinal

the main class to read a Writerperfect file More...

`#include <WriterPlsParser.hxx>`

Inheritance diagram for WriterPlsParser:

## Public Member Functions
| WriterPlsParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~WriterPlsParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo ()
| read the print info zone
bool | readWindowsInfo (int zone)
| read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )
bool | sendWindow (int zone, MWAWVec2i limits=MWAWVec2i(-1,-1))
| send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )
bool | readWindowsZone (int zone)
| read the page info zone
bool | readPageInfo (int zone)
| read the page info zone
bool | readColInfo (int zone)
| read the col info zone ?
bool | readParagraphInfo (int zone)
| read the paragraph info zone
bool | findSection (int zone, MWAWVec2i limits, MWAWSection &sec)
| try to find the data which correspond to a section ( mainly column )
bool | readSection (WriterPlsParserInternal::ParagraphInfo const &info, bool mainBlock)
| read a section
bool | readText (WriterPlsParserInternal::ParagraphInfo const &info)
| read a text
bool | readTable (WriterPlsParserInternal::ParagraphInfo const &info)
| read a table
bool | readGraphic (WriterPlsParserInternal::ParagraphInfo const &info)
| read a graphic
bool | readUnknown (WriterPlsParserInternal::ParagraphInfo const &info)
| read a unknown section
double | getTextHeight () const
| returns the page height, ie. paper size less margin (in inches) and header/footer
void | newPage (int number)
| adds a new page
bool | readParagraphData (WriterPlsParserInternal::ParagraphInfo const &info, bool hasFonts, WriterPlsParserInternal::ParagraphData &data)
| reads a paragraph data
MWAWParagraph | getParagraph (WriterPlsParserInternal::ParagraphData const &data)
| returns a paragraph corresponding to a paragraph data
bool | readFonts (int nFonts, int type, std::vector< WriterPlsParserInternal::Font > &fonts)
| reads a list of font (with position)
bool | readLines (WriterPlsParserInternal::ParagraphInfo const &info, int nLines, std::vector< WriterPlsParserInternal::Line > &lines)
| reads a list of line (with position)
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< WriterPlsParserInternal::State > | m_state
| the state

## Friends
class | WriterPlsParserInternal::SubDocument

## Detailed Description

the main class to read a Writerperfect file

## Constructor & Destructor Documentation

## ◆ WriterPlsParser()

WriterPlsParser::WriterPlsParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~WriterPlsParser()

WriterPlsParser::~WriterPlsParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool WriterPlsParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void WriterPlsParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool WriterPlsParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ findSection()

bool WriterPlsParser::findSection | ( | int | zone,
|  | MWAWVec2i | limits,
|  | MWAWSection & | sec )
| protected

try to find the data which correspond to a section ( mainly column )

Referenced by sendWindow().

## ◆ getParagraph()

MWAWParagraph WriterPlsParser::getParagraph | ( | WriterPlsParserInternal::ParagraphData const & | data | ) |
| protected

returns a paragraph corresponding to a paragraph data

Referenced by readText().

## ◆ getTextHeight()

double WriterPlsParser::getTextHeight | ( |  | ) | const
| protected

returns the page height, ie. paper size less margin (in inches) and header/footer

Referenced by readPageInfo().

## ◆ init()

void WriterPlsParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by WriterPlsParser().

## ◆ newPage()

void WriterPlsParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendWindow().

## ◆ parse()

void WriterPlsParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readColInfo()

bool WriterPlsParser::readColInfo | ( | int | zone | ) |
| protected

read the col info zone ?

Referenced by readWindowsZone().

## ◆ readFonts()

bool WriterPlsParser::readFonts | ( | int | nFonts,
|  | int | type,
|  | std::vector< WriterPlsParserInternal::Font > & | fonts )
| protected

reads a list of font (with position)

Referenced by readParagraphData().

## ◆ readGraphic()

bool WriterPlsParser::readGraphic | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a graphic

Referenced by sendWindow().

## ◆ readLines()

bool WriterPlsParser::readLines | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | int | nLines,
|  | std::vector< WriterPlsParserInternal::Line > & | lines )
| protected

reads a list of line (with position)

Referenced by readText().

## ◆ readPageInfo()

bool WriterPlsParser::readPageInfo | ( | int | zone | ) |
| protected

read the page info zone

Referenced by readWindowsZone().

## ◆ readParagraphData()

bool WriterPlsParser::readParagraphData | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | bool | hasFonts,
|  | WriterPlsParserInternal::ParagraphData & | data )
| protected

reads a paragraph data

Referenced by readGraphic(), readSection(), readTable(), readText(), and readUnknown().

## ◆ readParagraphInfo()

bool WriterPlsParser::readParagraphInfo | ( | int | zone | ) |
| protected

read the paragraph info zone

Referenced by readWindowsZone().

## ◆ readPrintInfo()

bool WriterPlsParser::readPrintInfo | ( |  | ) |
| protected

read the print info zone

Referenced by checkHeader(), and createZones().

## ◆ readSection()

bool WriterPlsParser::readSection | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | bool | mainBlock )
| protected

read a section

Referenced by sendWindow().

## ◆ readTable()

bool WriterPlsParser::readTable | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a table

Referenced by sendWindow().

## ◆ readText()

bool WriterPlsParser::readText | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a text

Referenced by sendWindow().

## ◆ readUnknown()

bool WriterPlsParser::readUnknown | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a unknown section

Referenced by sendWindow().

## ◆ readWindowsInfo()

bool WriterPlsParser::readWindowsInfo | ( | int | zone | ) |
| protected

read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by checkHeader(), and createZones().

## ◆ readWindowsZone()

bool WriterPlsParser::readWindowsZone | ( | int | zone | ) |
| protected

read the page info zone

Referenced by createZones().

## ◆ sendWindow()

bool WriterPlsParser::sendWindow | ( | int | zone,
|  | MWAWVec2i | limits = MWAWVec2i(-1,-1) )
| protected

send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by parse(), and sendWindow().

## Friends And Related Symbol Documentation

## ◆ WriterPlsParserInternal::SubDocument

friend class WriterPlsParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<WriterPlsParserInternal::State> WriterPlsParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), findSection(), getTextHeight(), init(), newPage(), readColInfo(), readPageInfo(), readParagraphInfo(), readWindowsInfo(), readWindowsZone(), and sendWindow().

The documentation for this class was generated from the following files:

- WriterPlsParser.hxx
- WriterPlsParser.cxx